import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.Color;

/**
 * Write a description of class Escenario here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Escenario  extends World
{
    private int dificultad;
    private VidaTotal vidas;
    private Contador cont;
    private Mensaje perder;
    private Mensaje jugar;
    private Mensaje objE;
    private Mensaje nivel;
    private Mensaje menu;
    private boolean perdiste;
    private int vidasTotal;
    private GreenfootSound audio;
    private int cantObs;
    private boolean opcion;
    private boolean perdiendo;
    
    public Escenario(){
        super(539, 453, 1); 
        perdiendo = opcion = false;
        audio = new GreenfootSound("intro.mp3");
        Greenfoot.setSpeed(33);
        dibujaMenu();
        creaMensajes();
        setPaintOrder(Mensaje.class, 
                      Boton.class, 
                      Vida.class, 
                      Personaje.class,
                      Utileria.class);
        setActOrder(Utileria.class, 
                    Personaje.class);                

    }
    
    public void dibujaMenu(){
        setBackground("portada.png");
        BotonAnimado boton= new BotonJugar();
        addObject(boton,240,320);
        boton = new BotonAyuda();
        addObject(boton,345,370);
        boton = new BotonCreditos();
        addObject(boton,405,420);
    }
    
    public void cambiaSonido(String archivoAudio){
        audio.stop();
        audio = new GreenfootSound(archivoAudio);
        audio.playLoop();
    }
    
    public void iniciarJuego(){
        cantObs = 30;
        dificultad = 1;
        poblar();
        vidasTotal = 5;
        vidas = new VidaTotal(vidasTotal);
        addObject(vidas,0,0);
        cont = new Contador(cantObs);
        GreenfootImage aux= cont.getImage();        
        addObject(cont,getWidth() - aux.getWidth()/2-2,getHeight() - aux.getHeight()/2);
        cambiaSonido("fondo.mp3");
    }
    
    
    public void poblar(){
        int x = 25;
        Actor nvo;
        nvo = new Padre();
        addObject(nvo, x, 73);
        nvo = new Madre();
        addObject(nvo, x, 190);
        nvo = new HijoMayor();
        addObject(nvo, x, 285);
        nvo = new HijoMenor();
        addObject(nvo, x, 390);
        for(int i = 0; i < 12; i++){
            colocaNube();
        }
    }

    public void act(){
        if(opcion){
                jugar();
        }
    }
   
    public void cambiaOpcion(boolean opcion){
        this.opcion = opcion;
    }
    
    public boolean kbhit(){
        if(Greenfoot.getKey() == null)  return false;
        return true;
    }
      
    public void started(){
        audio.playLoop();
    }
    
    public void stopped(){
        audio.pause();
    }
    
    public void jugar(){
        colocaNube(getWidth());
        if(vidas.yaPerdio()){       
            terminarJuego();
        }
        else{
            colocaObstaculo();
            avanzaNivel();
        }
        if(vidas.dameVidasRest() <= 1 && !perdiendo){
            cambiaSonido("perdiendo.mp3");
            perdiendo = true;
        }
        cancelarJuego();
        reiniciarJuego();
    }

    public void terminarJuego(){
        if(!perdiste){
            cambiaSonido("perdiste.mp3");
            dibujarPerdiste();
            perdiste = true;
        }
        List<Obstaculo> obs = getObjects(Obstaculo.class);
        removeObjects(obs);
        cancelarJuego();
        if(reiniciarJuego()){
            eliminaMensajes();
            creaMensajes();
            cambiaSonido("fondo.mp3");
        }
    }
    
    public boolean reiniciarJuego(){
        if(Greenfoot.isKeyDown("enter")){
            List<Obstaculo> obs = getObjects(Obstaculo.class);
            removeObjects(obs);
            perdiste = false;
            perdiendo = false;
            cont.reiniciaCont(cantObs);
            vidas.reiniciaVidas();            
            dificultad = 1;
            addObject(new Mensaje(50, "START", Color.yellow,1), getWidth()/2, getHeight()/2);
            return true;
        }
        return false;
    }    

    public void cancelarJuego(){
        if(Greenfoot.isKeyDown("space")){
            removeObjects(getObjects(Actor.class));
            dibujaMenu();
            opcion = false;
            perdiste = false;
            perdiendo = false;
            cambiaSonido("intro.mp3");
        }
    }
    
    public void eliminaMensajes(){
        removeObject(perder);
        removeObject(jugar);
        removeObject(objE);
        removeObject(nivel);
        removeObject(menu);
    }
    
    public void creaMensajes(){
        perder = new Mensaje(30,"YOU LOSE",Color.white,0);
        jugar = new Mensaje(30,"press ENTER to play again",Color.white,2);
        menu = new Mensaje(30,"press SPACE to main menu",Color.white,2);
    }
    
    public void dibujarPerdiste(){
        decrementaContador();
        int objEsq = cantObs*(dificultad-1)+cantObs-cont.dameCuenta();
        objE = new Mensaje(30,"LEFT OBSTACLES: "+objEsq,Color.white,0);
        nivel = new Mensaje(30,"LEVEL: "+dificultad,Color.white,0);
        addObject(perder,getWidth()/2,getHeight()/2+perder.getImage().getHeight()/2*(-3));
        addObject(jugar,getWidth()/2,getHeight()/2+perder.getImage().getHeight()/2*3);        
        addObject(menu,getWidth()/2,getHeight()/2+perder.getImage().getHeight()/2*5);        
        addObject(objE,getWidth()/2,getHeight()/2+perder.getImage().getHeight()/2*1);
        addObject(nivel,getWidth()/2,getHeight()/2+perder.getImage().getHeight()/2*(-1));
    }

    public void avanzaNivel(){
        if(cont.dameCuenta() == 0){
          //  Greenfoot.playSound("clear.mid");
            dificultad++;
            addObject(new Mensaje(50,"LEVEL: "+dificultad,Color.white,1), getWidth()/2,getHeight()/2);
            cont.reiniciaCont(cantObs);
            vidas.reiniciaVidas();
        }
    }
    
    public void disminuyeVida(){
        vidas.vidaMenos();
    }
    
    public void decrementaContador(){
        cont.decrementa();
    }
    
    public void colocaObstaculo(){
        Obstaculo aux = null;
        List<Obstaculo> l= getObjects(Obstaculo.class);
        if(Greenfoot.getRandomNumber(100) < dificultad || l.isEmpty()){
            switch(Greenfoot.getRandomNumber(4)){
                case 0: aux = creaPiedra();
                        break;
                case 1: aux = creaInsectos();
                        break;
                case 2: aux = creaAguila();
                        break;
                case 3: aux = creaDesnivel();
                        break;
            }
            if(aux.existeAnt(Obstaculo.class) || aux.restringir()){
                removeObject(aux);
            }
        }
    }   
    
    public Obstaculo creaInsectos(){
        Obstaculo nvo = null;
        int y = 200;
        switch(Greenfoot.getRandomNumber(2)){
            case 0:
                nvo = new Cucaracha();
                addObject((Cucaracha)nvo, getWidth(), y);
                break;
            case 1: 
                nvo = new Catarina();
                addObject((Catarina)nvo, getWidth(), y);
                break;
        }
        return nvo;
    }
    
    public Obstaculo creaPiedra(){
        Piedra nvo = new Piedra();
        addObject(nvo, getWidth(), 77);
        return (Obstaculo)nvo;
    }
    
    public Obstaculo creaAguila(){
        Aguila nvo = new Aguila();
        addObject(nvo, getWidth(), 270);
        return (Obstaculo)nvo;
    }
    
    public Obstaculo creaDesnivel(){
        Desnivel nvo = new Desnivel();
        addObject(nvo, getWidth(), getHeight()-26);
        return (Obstaculo)nvo;
    }
    
    public boolean colocaNube(int x){
        Nube nube = new Nube();
        if(Greenfoot.getRandomNumber(100)>2){
            int varY = Greenfoot.getRandomNumber(10);
            int y = obtenYNube();
            addObject(nube, x, y + varY);
            if(nube.existeAnt(nube.getImage().getWidth()*4, Nube.class)){
                removeObject(nube);
                return true;
            }
        }
        return false;
    }
    
    public void colocaNube(){
        if(colocaNube(Greenfoot.getRandomNumber(getWidth())))
            colocaNube();
    }
    
    public int obtenYNube(){
        int y = 0;
        switch(Greenfoot.getRandomNumber(4)){
            case 0: y = 30;
                    break;
            case 1: y = 145;
                    break;
            case 2: y = 265;
                    break;
            case 3: y = getHeight()-95;
                    break;
        }
        return y;
    }
}
