import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

public class Madre  extends Personaje
{
    private int actuaciones;
    private MouseInfo raton;
    private int xIni;
    private int ancho;
    private int actTotal;
    
    public Madre(){
        super("Mama",".png",4);
        teclaU = "S";
        teclaL = teclaU.toLowerCase();
        actTotal = actuaciones = 2;
        ancho = getImage().getWidth();
        tecla = new Boton(teclaU,Color.magenta,actTotal);
    }    
    
    public void act(){
        if(accion){
            accion();
            Obstaculo obs = (Obstaculo)getOneIntersectingObject(Obstaculo.class);
            if(obs != null){
                if(obs instanceof Cucaracha){
                    escen.removeObject(obs);
                    escen.decrementaContador();
                }
                else if(obs instanceof Catarina && !intersecto){
                    intercambiaImagenTransp();
                    Greenfoot.playSound("suspiro.mp3");
                    escen.disminuyeVida();
                }
            }
        }
        else{
            Obstaculo obs = (Obstaculo)getOneIntersectingObject(Obstaculo.class);                
            if(obs !=null){
                if(obs instanceof Catarina){
                    Greenfoot.playSound("exp.mp3");
                    escen.removeObject(obs);
                    escen.decrementaContador();
                }
                else if(obs instanceof Cucaracha){
                    if(!intersecto){
                        Greenfoot.playSound("grito.mp3");
                        setImage("MamaX.png");
                        escen.disminuyeVida();
                        intersecto = true;
                    }
                    intercambiaImagenTransp();
                }
            }
            else{
                super.act();
                setLocation(xIni,getY());
            }
        }
    }
    
    public void addedToWorld(World world){
        xIni = getX();
        escen = (Escenario)getWorld();
        escen.addObject(tecla, xIni,232);        
    }
    
    public void accion(){    
        if(actuaciones == actTotal){
            Greenfoot.playSound("aplastar.mp3");
            setImage("MamaAct.png");
            setLocation((getImage().getWidth()-ancho)/2+xIni,getY());
        }
        actuaciones--;
        if(actuaciones == 0){
            accion = false;
            actuaciones = actTotal;
        }
    }    
    
    
}
