import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

public class Padre  extends Personaje
{
    private int y;
    private int yIni;
    private boolean salta;
    private static final int aumento = 15;
    private int x;
    private int altura;

    public Padre(){
        super("Papa",".png",4);
        teclaL = "a";
        teclaU = teclaL.toUpperCase();
        altura = getImage().getHeight();
        salta = false;
        tecla = new Boton(teclaU,Color.YELLOW);
    }  
    
    public void addedToWorld(World world){
        y = yIni = getY();
        x = getX();
        escen = (Escenario)getWorld();
        escen.addObject(tecla, x,108);
    }
    
    public void act(){
        salta = estaSaltando();
        if(detectaObstaculo(altura/2)){            
            if(!intersecto){
                Greenfoot.playSound("piedras.mp3");
                setImage("PapaX.png");
                escen.disminuyeVida();
                intersecto = true;
            }
            intercambiaImagenTransp();
        }
        else{
            if(!accion){
                super.act();
            }
            else{
                setImage("Papa1.png");
                accion();
            }
        }
    }
    
    public void accion(){  
        if(salta){
            y -= aumento;
            if( y <= yIni - altura)
                salta = false;
        }
        else{
            y += aumento;
            if(y >= yIni)
                accion = false;
        }
        setLocation(x,y);
    }
    
    public boolean estaSaltando(){
        if(accion && y == yIni){
            Greenfoot.playSound("salto.mp3");
            return true;
        }
        else return salta;
    }
}
